﻿using System;
using System.Linq;
using Microsoft.SharePoint;
using System.Data;
using NPOI;
using NPOI.POIFS;
using NPOI.HSSF;
using NPOI.Util;
using NPOI.HSSF.UserModel;
using System.IO;
using NPOI.SS.UserModel;
using System.Xml;
using System.Collections;


namespace SharePointConsoleApplication1
{
    class Program
    {


        static void Main(string[] args)
        {
            //NewMethod();
            Additems();
        }

        private static void Additems()
        {
            using (SPSite oSite = new SPSite("http://win-3efv2ngqv0h/excel"))
            {
                using (SPWeb oWeb = oSite.OpenWeb())
                {
                    // 用户保存字段静态名字和显示名称对应的hash表
                    Hashtable fieldLists = new Hashtable();

                    SPList oList = oWeb.Lists["Excel"];
                    for (int i = 5000; i < 100000; i++)
                    {
                        SPListItem oItem = oList.Items.Add();
                        oItem["标题"] = "我的任务" + i.ToString();
                        oItem.Update();
                    }
                }
            }
            Console.Read();
        }

        private static void NewMethod()
        {
            //DataTable dt = new DataTable();
            using (SPSite oSite = new SPSite("http://win-3efv2ngqv0h/excel"))
            {
                using (SPWeb oWeb = oSite.OpenWeb())
                {
                    // 用户保存字段静态名字和显示名称对应的hash表
                    Hashtable fieldLists = new Hashtable();

                    SPList oList = oWeb.Lists["任务"];
                    SPView view = oList.Views["我的任务"]; ;
                    SPListItemCollection items = oList.GetItems(view);
                    ArrayList al = new ArrayList();
                    foreach (string fieldName in view.ViewFields)
                    {
                        al.Add(fieldName);
                        // 利用栏的内部名称读取栏，并将静态名作为key，显示名作为值添加到哈希表
                        SPField oField = oList.Fields.GetFieldByInternalName(fieldName);
                        fieldLists.Add(fieldName, oField.Title);
                    }
                    DataTable dt2 = items.GetDataTable();

                    HSSFWorkbook hssfworkbook = new HSSFWorkbook();
                    CellStyle headerStyle = SetHeaderStyle(hssfworkbook);
                    CellStyle bodyStyle = SetBodyStyle(hssfworkbook);
                    Sheet sheet = hssfworkbook.CreateSheet("new sheet");
                    Row rowHeader = sheet.CreateRow(0);
                    int columnCount = dt2.Columns.Count;
                    for (int i = 0; i < columnCount; ++i)
                    {
                        // 如果表中的字段数字和已经等于视图中的字段个数，就不需要在处理，直接跳出。
                        if (dt2.Columns.Count == al.Count)
                            break;
                        // 判断是否是视图中的字段。
                        if (al.Contains(dt2.Columns[i].ColumnName))
                        {
                            string fieldTitle = fieldLists[dt2.Columns[i].ColumnName].ToString();
                            Cell cell = rowHeader.CreateCell(i);
                            cell.SetCellValue(fieldTitle);
                            cell.CellStyle = headerStyle;
                            sheet.SetColumnWidth(i, SetCulomnWidth(fieldTitle) * 256);
                        }
                        else
                        {
                            dt2.Columns.Remove(dt2.Columns[i].ColumnName);
                            // 索引重置，因为已经删除了该字段，所以目前该字段位置保存的是下一个字段的名称，所以要重置，再次读取该值。
                            i -= 1;
                        }
                    }

                    for (int i = 0; i < dt2.Rows.Count; i++)
                    {
                        Row rowBody = sheet.CreateRow(i + 1);
                        for (int j = 0; j < dt2.Columns.Count; j++)
                        {
                            Cell cell = rowBody.CreateCell(j);
                            cell.CellStyle = bodyStyle;
                            cell.SetCellValue(dt2.Rows[i][j].ToString());
                        }
                    }
                    ////
                    FileStream file = new FileStream(@"test.xls", FileMode.Create);
                    hssfworkbook.Write(file);
                    file.Close();
                }
            }
        }

        private static CellStyle SetHeaderStyle(HSSFWorkbook p_workbook)
        {
            CellStyle style = p_workbook.CreateCellStyle();
            Font font = p_workbook.CreateFont();
            style.Alignment = HorizontalAlignment.CENTER;
            font.Boldweight = (short)FontBoldWeight.BOLD;
            style.SetFont(font);
            style.BorderBottom = CellBorderType.THIN;
            style.BorderLeft = CellBorderType.THIN;
            style.BorderRight = CellBorderType.THIN;
            style.BorderTop = CellBorderType.THIN;
            style.FillBackgroundColor = NPOI.HSSF.Util.HSSFColor.RED.index;
            return style;
        }

        private static CellStyle SetBodyStyle(HSSFWorkbook p_workbook)
        {
            CellStyle style = p_workbook.CreateCellStyle();
            style.BorderBottom = CellBorderType.THIN;
            style.BorderLeft = CellBorderType.THIN;
            style.BorderRight = CellBorderType.THIN;
            style.BorderTop = CellBorderType.THIN;
            return style;
        }

        private static int SetCulomnWidth(string p_fieldName)
        {
            byte[] byteStr = System.Text.Encoding.Default.GetBytes(p_fieldName);
            return (2 * p_fieldName.Length + 1) * 3;
        }
    }
}
